function [LB,UB,D,fobj,quantis,error] = getFunc(F)
global GetFunInfoAddr fun
quantis=[];
error=false;

% CEC2011 benchmark
if strncmp(F,'CEC2011',7)
    nn=F(9:10);
    fun=str2double(nn);
    [LB, UB, D, ~, ~] = GetFunInfoAddr(fun);
    fobj = @CEC2011;
   return
end

%--------------------------------------------------------------------------
switch F

    case 'F1'
        fobj = @F1;
        D=1; % 50
       % UB=zeros(1,D); LB=-200; 
        UB=100*ones(1,D); LB=-UB;
        
        
    case 'F2'
        fobj = @F2;
        D=50;
        UB=10*ones(1,D);
        LB=-UB;
        
    case 'F3'
        fobj = @F3;
        D=50;
        UB=100*ones(1,D);;
        LB=-UB;
        
    case 'F4'
        fobj = @F4;
        D=50;
        UB=100*ones(1,D);
        LB=-UB;
        
    case 'F5'
        fobj = @F5;
        D=50;
        UB=30*ones(1,D);
        LB=-UB;
        
    case 'F6'
        fobj = @F6;
        D=50;
        UB=100*ones(1,D);
        LB=-UB;
        
    case 'F7'
        fobj = @F7;
        D=50;
        UB=1.28*ones(1,D);
        LB=-UB;
        
    case 'F8'
        fobj = @F8;
        D=50;
        UB=500*ones(1,D);
        D=50;
        LB=-UB;
        
    case 'F9' % Rastrigin
        fobj = @F9;
        D=10;
        UB=5.12*ones(1,D);
        LB=-UB;
        
    case 'F10'
        fobj = @F10;
        D=50;
        UB=32*ones(1,D);
        LB=-UB;
        
    case 'F11'
        fobj = @F11;
        D=50;
        UB=600*ones(1,D);
        LB=-UB;
        
    case 'F12'
        fobj = @F12;
        D=50;
        UB=50*ones(1,D);
        LB=-UB;
        
    case 'F13'
        fobj = @F13;
        D=50;
        UB=50*ones(1,D);
        LB=-UB;
        
    case 'F14'
        fobj = @F14;
        D=2;
        UB=65.536*ones(1,D);
        LB=-UB;
        
    case 'F15'
        fobj = @F15;;
        D=4;
        UB=5*ones(1,D);
        LB=-UB;
        
    case 'F16'
        fobj = @F16;
        D=2;
        UB=5*ones(1,D);
        LB=-UB;
        
    case 'F17'
        fobj = @F17;
        D=2;
        LB=[-5,0];
        UB=[10,15];
        
    case 'F18'
        fobj = @F18;
        D=2;
        UB=2*ones(1,D);;
        LB=-UB;
        
    case 'F19'
        fobj = @F19;
        D=3;
        LB=zeros(1,D);
        UB=ones(1,D);
        
    case 'F20'
        fobj = @F20;
        D=6;
        LB=zeros(1,D);
        UB=ones(1,D);
        
    case 'F21'
        fobj = @F21;
        LB=0;
        UB=10;
        D=4;
        
    case 'F22'
        fobj = @F22;
        D=4;
        LB=zeros(1,D);
        UB=10*ones(1,D);
        
    case 'F23'
        fobj = @F23;;
        D=4;
        LB=zeros(1,D);
        UB=10*ones(1,D);
        
    case 'F24'
        fobj = @F24;
        D=20;
        UB=500*ones(1,D);
        LB=-UB;
        
    case 'Dice' % Brandeis dice, max entropy
        fobj=@Dice;
        D=6;
        LB=zeros(1,D);
        UB=ones(1,D);
        
    case'CEC2019_01'
        fobj = @CEC2019_01;
        D=9;
        UB=8192*ones(1,D);
        LB=-UB;
        
    case'CEC2019_02'
        fobj = @CEC2019_02;
        D=16;
        UB=16384*ones(1,D);
        LB=-UB;
        
    case'CEC2019_03'
        fobj = @CEC2019_03;
        D=18;
        UB=4*ones(1,D);
        LB=-UB;
        
    case'CEC2019_04'
        fobj = @CEC2019_04;
        D=10;
        UB=100*ones(1,D);
        LB=-UB;
        
    case'CEC2019_05'
        fobj = @CEC2019_05;
        D=10;
        UB=100*ones(1,D);
        LB=-UB;
        
    case'CEC2019_06'
        fobj = @CEC2019_06;
        D=10;
        UB=100*ones(1,D);
        LB=-UB;
        
    case'CEC2019_07'
        fobj = @CEC2019_07;
        D=10;
        UB=100*ones(1,D);
        LB=-UB;
        
    case'CEC2019_08'
        fobj = @CEC2019_08;
        D=10;
        UB=100*ones(1,D);
        LB=-UB;
        
    case'CEC2019_09'
        fobj = @CEC2019_09;
        D=10;
        UB=100*ones(1,D);
        LB=-UB;
        
    case'CEC2019_10'
        fobj = @CEC2019_10;
        D=10;
        UB=100*ones(1,D);
        LB=-UB;
        
    case 'Plateau'
        fobj=@Plateau;
        D=2;
        UB=ones(1,D);
        LB=-UB;
        
    case 'P_Vessel'
        % Pressure vessel
        % (constraints as penalties, see get_fun_info.m)
        % Theoretical solution:
        % f(0.8125 0.4375 42.0984455958549 176.6365958424394)=6059.714335048436
        % "True global optimality of the pressure vessel design problem" by Xin-She Yang
        fobj=@P_Vessel;
        D=4;
        q=0.0625;
        LB=[q q 10 10];
        UB=[99 99 200 200];
        quantis=[q q 0 0];
        
    case 'Gear_train'
        fobj=@Gear_train;
        % Min 2.700857e-12
        % (16 19 43 49)
        D=4;
        ones4=ones(1,4);
        LB=12*ones4;
        UB=60*ones4;
        quantis=ones4;
      
        % Actually, when looking at f (see func.m), it is easy to see that
        %	  for the minimum we must have
        %		x1, x2 in {13,14, ...,39}, and
        %		x3, x4 in {17, 18, ..., 60}
        
    otherwise
        fprintf('\n I am afraid %s is not implemented \n',F);
        error=true;
        LB=[]; UB=[]; D=[];fobj=[]; quantis=[];
end
end

%---------------------------------------------------------------------- Formulae
function o=CEC2011(x)
    global fun FuncAddr
    o=FuncAddr(x, fun, 0);
end


% F1 Sphere
function o = F1(x)
o=sum(x.^2);
%o=sum((x+100).^2);
end

% F2
function o = F2(x)
o=sum(abs(x))+prod(abs(x));
end

% F3
function o = F3(x)
D=size(x,2);
o=0;
for i=1:D
    o=o+sum(x(1:i))^2;
end
end

% F4
function o = F4(x)
o=max(abs(x));
end

% F5  Rosenbrock
function o = F5(x)
D=size(x,2);
o=sum(100*(x(2:D)-(x(1:D-1).^2)).^2+(x(1:D-1)-1).^2);
end

% F6
function o = F6(x)
o=sum(abs((x+.5)).^2);
end

% F7
function o = F7(x)
D=size(x,2);
o=sum([1:D].*(x.^4))+rand;
end

% F8
function o = F8(x)
o=sum(-x.*sin(sqrt(abs(x))));
end

% F9 Rastrigin
function o = F9(x)
D=size(x,2);
% Shifted % MC
%u=-1+2*rand(1,D);
u=[ 0.744494038956004   0.178823065507230   0.674213268601839  -0.780911101495091  -0.173362528262202 ...
    -0.442505303176209   0.425768949068865   0.365060760014257   0.193619287547462  -0.763915854600650];
x=x+u;

o=sum(x.^2-10*cos(2*pi.*x))+10*D;
end

% F10  Ackley
function o = F10(x)
D=size(x,2);
o=-20*exp(-.2*sqrt(sum(x.^2)/D))-exp(sum(cos(2*pi.*x))/D)+20+exp(1);
end

% F11  Griewank
function o = F11(x)
D=size(x,2);
o=sum(x.^2)/4000-prod(cos(x./sqrt([1:D])))+1;
end

% F12
function o = F12(x)
D=size(x,2);
o=(pi/D)*(10*((sin(pi*(1+(x(1)+1)/4)))^2)+sum((((x(1:D-1)+1)./4).^2).*...
    (1+10.*((sin(pi.*(1+(x(2:D)+1)./4)))).^2))+((x(D)+1)/4)^2)+sum(Ufun(x,10,100,4));
end

% F13
function o = F13(x)
D=size(x,2);
o=.1*((sin(3*pi*x(1)))^2+sum((x(1:D-1)-1).^2.*(1+(sin(3.*pi.*x(2:D))).^2))+...
    ((x(D)-1)^2)*(1+(sin(2*pi*x(D)))^2))+sum(Ufun(x,5,100,4));
end

% F14
function o = F14(x)
aS=[-32 -16 0 16 32 -32 -16 0 16 32 -32 -16 0 16 32 -32 -16 0 16 32 -32 -16 0 16 32;,...
    -32 -32 -32 -32 -32 -16 -16 -16 -16 -16 0 0 0 0 0 16 16 16 16 16 32 32 32 32 32];

for j=1:25
    bS(j)=sum((x'-aS(:,j)).^6);
end
o=(1/500+sum(1./([1:25]+bS))).^(-1);
end

% F15
function o = F15(x)
aK=[.1957 .1947 .1735 .16 .0844 .0627 .0456 .0342 .0323 .0235 .0246];
bK=[.25 .5 1 2 4 6 8 10 12 14 16];bK=1./bK;
o=sum((aK-((x(1).*(bK.^2+x(2).*bK))./(bK.^2+x(3).*bK+x(4)))).^2);
end

% F16
function o = F16(x)
o=4*(x(1)^2)-2.1*(x(1)^4)+(x(1)^6)/3+x(1)*x(2)-4*(x(2)^2)+4*(x(2)^4);
end

% F17
function o = F17(x)
o=(x(2)-(x(1)^2)*5.1/(4*(pi^2))+5/pi*x(1)-6)^2+10*(1-1/(8*pi))*cos(x(1))+10;
end

% F18
function o = F18(x)
o=(1+(x(1)+x(2)+1)^2*(19-14*x(1)+3*(x(1)^2)-14*x(2)+6*x(1)*x(2)+3*x(2)^2))*...
    (30+(2*x(1)-3*x(2))^2*(18-32*x(1)+12*(x(1)^2)+48*x(2)-36*x(1)*x(2)+27*(x(2)^2)));
end

% F19
function o = F19(x)
aH=[3 10 30;.1 10 35;3 10 30;.1 10 35];cH=[1 1.2 3 3.2];
pH=[.3689 .117 .2673;.4699 .4387 .747;.1091 .8732 .5547;.03815 .5743 .8828];
o=0;
for i=1:4
    o=o-cH(i)*exp(-(sum(aH(i,:).*((x-pH(i,:)).^2))));
end
end

% F20
function o = F20(x)
aH=[10 3 17 3.5 1.7 8;.05 10 17 .1 8 14;3 3.5 1.7 10 17 8;17 8 .05 10 .1 14];
cH=[1 1.2 3 3.2];
pH=[.1312 .1696 .5569 .0124 .8283 .5886;.2329 .4135 .8307 .3736 .1004 .9991;...
    .2348 .1415 .3522 .2883 .3047 .6650;.4047 .8828 .8732 .5743 .1091 .0381];
o=0;
for i=1:4
    o=o-cH(i)*exp(-(sum(aH(i,:).*((x-pH(i,:)).^2))));
end
end

% F21
function o = F21(x)
aSH=[4 4 4 4;1 1 1 1;8 8 8 8;6 6 6 6;3 7 3 7;2 9 2 9;5 5 3 3;8 1 8 1;6 2 6 2;7 3.6 7 3.6];
cSH=[.1 .2 .2 .4 .4 .6 .3 .7 .5 .5];

o=0;
for i=1:5
    o=o-((x-aSH(i,:))*(x-aSH(i,:))'+cSH(i))^(-1);
end
end

% F22
function o = F22(x)
aSH=[4 4 4 4;1 1 1 1;8 8 8 8;6 6 6 6;3 7 3 7;2 9 2 9;5 5 3 3;8 1 8 1;6 2 6 2;7 3.6 7 3.6];
cSH=[.1 .2 .2 .4 .4 .6 .3 .7 .5 .5];

o=0;
for i=1:7
    o=o-((x-aSH(i,:))*(x-aSH(i,:))'+cSH(i))^(-1);
end
end

% F23
function o = F23(x)
aSH=[4 4 4 4;1 1 1 1;8 8 8 8;6 6 6 6;3 7 3 7;2 9 2 9;5 5 3 3;8 1 8 1;6 2 6 2;7 3.6 7 3.6];
cSH=[.1 .2 .2 .4 .4 .6 .3 .7 .5 .5];

o=0;
for i=1:10
    o=o-((x-aSH(i,:))*(x-aSH(i,:))'+cSH(i))^(-1);
end
end

function o=Ufun(x,a,k,m)
o=k.*((x-a).^m).*(x>a)+k.*((-x-a).^m).*(x<(-a));
end

% F24
function o = F24(x)
o=sum(-x.*x.*sin(sqrt(abs(x))));
end

function o=Dice(x) % Brandeis dice, max entropy
% mainloop(100,25,6000,'Dice',4); % => min(-entropy)= -1.611
% => probabilities: 
% 0.05222805	0.06646256	0.1258512	0.1772572	0.2409415	0.3372595

dieMean=4.5; % Loaded die. 3.5 for a fair one

s=0;
p=abs(1-sum(x));
h=0;
D=length(x);
for d=1:D
    s=s+d*x(d);
    h=h+x(d)*log(x(d));
end

penalty=1000;
s=abs(s-dieMean);
o=h+penalty*(s+p); % Instead of 3.5 for normal dice


end

% CEC 2019 01
function o=CEC2019_01(x)
o=cec19_funcLinux(x',1); % Generated by mex
end

% CEC 2019 02
function o=CEC2019_02(x)
o=cec19_funcLinux(x',2); % Generated by mex
end

% CEC 2019 03
function o=CEC2019_03(x)
o=cec19_funcLinux(x',3); % Generated by mex
end

% CEC 2019 04
function o=CEC2019_04(x)
o=cec19_funcLinux(x',4); % Generated by mex
end

% CEC 2019 05
function o=CEC2019_05(x)
o=cec19_funcLinux(x',5); % Generated by mex
end

% CEC 2019 06
function o=CEC2019_06(x)
o=cec19_funcLinux(x',6); % Generated by mex
end

% CEC 2019 07
function o=CEC2019_07(x)
o=cec19_funcLinux(x',7); % Generated by mex
end

% CEC 2019 08
function o=CEC2019_08(x)
o=cec19_funcLinux(x',8); % Generated by mex
end

% CEC 2019 09
function o=CEC2019_09(x)
o=cec19_funcLinux(x',9); % Generated by mex
end

% CEC 2019 10
function o=CEC2019_10(x)
o=cec19_funcLinux(x',10); % Generated by mex
end

% Plateau (the Impossible Plaeau, used to plot a signature)
function o=Plateau(x)
o=1;
end

% Pressure Vessel
function o=P_Vessel(x)
o=0.6224*x(1)*x(3)*x(4) + 1.7781*x(2)*x(3)*x(3) ...
    + x(1)*x(1)*(3.1661*x(4) +19.84*x(3));

% Takes constraints into account (penalty method)
g(1)=0.0193*x(3)-x(1);
g(2)=0.00954*x(3)-x(2);
g(3)=1296000-pi*x(3)*x(3)*(x(4)+4*x(3)/3);

pw=10^10;
if g(1)>0 c= 1+pw*g(1);  o=o*c*c; end
if g(2)>0 c=1+pw*g(2); o=o*c*c;  end
if g(3)>0 c=1+pw*g(3); o=o*c*c;  end
end

% Gear train
function o=Gear_train(x)
z=1.0/6.931;
o=z-x(1)*x(2)/(x(3)*x(4));
o=o*o;
end


