function L = levy(N,D,beta, option)
%{
N     =  Number of steps
D    =  Number of Dimensions
beta  = Power law index  1 < beta < 2
option =  two possibles methods

Output
 L     = N levy steps in D dimensions

%}
switch option
    case 1
        for n=1:N
            for d=1:D
                L(n,d)=beta/norminv(1-rand)^2;
                if rand<0.5 L(n,d)=-L(n,d); end
            end
        end
  
    otherwise
        num = gamma(1+beta)*sin(pi*beta/2); 
        den = gamma((1+beta)/2)*beta*2^((beta-1)/2); 
        s = (num/den)^(1/beta);
        u = random('Normal',0,s,N,D);
        v = random('Normal',0,1,N,D);
        L =u./(abs(v).^(1/beta));
        
end
end
 

